(* tests for IsacKnowledge/DiffApp
   author Walther Neuper 000301
   (c) due to copyright terms

   use"../smltest/IsacKnowledge/diffapp.sml";
   use"diffapp.sml";
*)

"Contents----------------------------------------------";
"              Specify_Problem (match_itms_oris)       ";
"              test specify, fmz <> []                  ";
"              test specify, fmz = []                  ";
"          problemtypes + formalizations               ";
"-------------------- ptree of {(a,b). is-max ... ----------------";
"--------- me .. scripts for maximum-example ---------------------";
"--------- autoCalc .. scripts for maximum-example ---------------";

"--------------------- 30.4.03: maximum .. rewrite_set_ list_rls ---------";
"---------------------- 1.5.03: Make_fun_by_explicit ---------------------";
"---------------------- 2.5.03: Make_fun_by_new_variable -----------------";





" #################################################### ";
"          problemtypes + formalizations               ";
" #################################################### ";
" -------------- [maximum_of,function] --------------- ";
val pbt = 
    ["fixedValues fix_","maximum m_","valuesFor vs_","relations rs_"];
map (the o (parseold thy)) pbt;
val fmz =
    ["fixedValues [r=Arbfix]","maximum A",
     "valuesFor [a,b]",
     "relations [A=a*b, (a/2)^^^2 + (b/2)^^^2 = r^^^2]",
     "relations [A=a*b, (a/2)^^^2 + (b/2)^^^2 = r^^^2]",
     "relations [A=a*b, a/2=r*sin alpha, b/2=r*cos alpha]",

     "boundVariable a","boundVariable b","boundVariable alpha",
     "interval {x::real. 0 <= x & x <= 2*r}",
     "interval {x::real. 0 <= x & x <= 2*r}",
     "interval {x::real. 0 <= x & x <= pi}",
     "errorBound (eps=(0::real))"];
map (the o (parseold thy)) fmz;
" -------------- [make,function] -------------- ";
val pbt = 
    ["functionOf f_","boundVariable v_v","equalities eqs_",
     "functionTerm f_0_"];
map (the o (parseold thy)) pbt;
val fmz12 =
    ["functionOf A","boundVariable a","boundVariable b",
     "equalities [A=a*b, (a/2)^^^2 + (b/2)^^^2 = r^^^2]",
     (*28.11.00: "functionTerm (A_0=Undef)"*)"functionTerm (Undef)"];
map (the o (parseold thy)) fmz12;
val fmz3 =
    ["functionOf A","boundVariable a","boundVariable b",
     "equalities [A=a*b, a/2=r*sin alpha, b/2=r*cos alpha]",
     (*28.11.00: "functionTerm (A_0=Undef)"*)"functionTerm (Undef)"];
map (the o (parseold thy)) fmz3;
" --------- [univar,equation] --------- ";
val pbt = 
    ["equality e_e","solveFor v_v","solutions v_i_"];
map (the o (parseold thy)) pbt;
val fmz =
    ["equality ((a/2)^^^2 + (b/2)^^^2 = r^^^2)",
     "solveFor b","solutions b_i"];
map (the o (parseold thy)) fmz;
" ---- [on_interval,maximum_of,function] ---- ";
val pbt = 
    ["functionTerm t_","boundVariable v_v","interval itv_",
     "errorBound err_","maxArgument v_0_"];
map (the o (parseold thy)) pbt;
val fmz12 =
    [(*28.11.00: "functionTerm (A_0 = a*sqrt(#4*r^^^#2 - a^^^#2))",*)
     "functionTerm (a*sqrt(4*r^^^2 - a^^^2))",
     (*28.11.00: "functionTerm (A_0 = b*sqrt(#4*r^^^#2 - b^^^#2))",*)
     "functionTerm (b*sqrt(4*r^^^2 - b^^^2))",
     "boundVariable a","boundVariable b",
     "interval {x::real. 0 <= x & x <= 2*r}",
     "errorBound (eps=0)","maxArgument (a_0=Undef)"];
map (the o (parseold thy)) fmz12;
val fmz3 =
    [(*28.11.00: "functionTerm (A_0 = (#2*r*sin alpha)*(#2*r*cos alpha))",*)
     "functionTerm ((2*r*sin alpha)*(2*r*cos alpha))",
     "boundVariable alpha",
     "interval {x::real. 0 <= x & x <= pi}",
     "errorBound (eps=0)","maxArgument (a_0=Undef)"];
map (the o (parseold thy)) fmz3;
" --------- [derivative_of,function] --------- ";
val pbt = 
    ["functionTerm f_","boundVariable v_v","derivative f_'_"];
map (the o (parseold thy)) pbt;
val fmz =
    [(*28.11.00: "functionTerm (A_0=a*#2*sqrt r^^^#2 - (a//#2)^^^#2)",*)
     "functionTerm (a*2*sqrt r^^^2 - (a/2)^^^2)",
     "boundVariable a",
     (*28.11.00: "derivative (A_0'=Undef)"*)"derivative (Undef)"];
map (the o (parseold thy)) fmz;
" --------- [find_values,tool] --------- ";
val pbt = 
    ["maxArgument ma_","functionTerm f_","boundVariable v_v",
     "valuesFor vls_","additionalRels rs_"];
map (the o (parseold thy)) pbt;
val fmz1 =
    ["maxArgument (a_0=(srqt 2)*r)",
     (*28.11.00: "functionTerm (A_0=a*#2*sqrt r^^^#2 - (a//#2)^^^#2)",*)
     "functionTerm (a*2*sqrt r^^^2 - (a/2)^^^2)",
     "boundVariable a",
     "valuesFor [a,b]","maximum A",
     "additionalRels [(a/2)^^^2 + (b/2)^^^2 = r^^^2]"];
map (the o (parseold thy)) fmz1;



"-------------------- ptree of {(a,b). is-max ... --------------------------";
"-------------------- ptree of {(a,b). is-max ... --------------------------";
"-------------------- ptree of {(a,b). is-max ... --------------------------";

(* Teil von max-on-surface.sml,
   der nach Init_Proof -> prep_ori wieder l"auft
   (f"ur tests mit neuer pos')
   use"test-max-surf1.sml";

   Compiler.Control.Print.printDepth:=7; (*4 is default*)
   Compiler.Control.Print.printDepth:=4; (*4 is default*)
   *)

(* --vvv-- ausgeliehen von test-root-equ/sml *)
val loc = e_istate;
val (dI',pI',mI') =
  ("Script.thy",["sqroot-test","univariate","equation"],
   ["Script","squ-equ-test2"]);
val fmz = ["equality (sqrt(9+4*x)=sqrt x + sqrt(5+x))",
	   "solveFor x","errorBound (eps=0)",
	   "solutions L"];
(*
val (mI,m) = ("Init_Proof",Init_Proof (fmz, (dI',pI',mI')));
val ((p,p_),_,_,_,_,(_,pt,_)) = do_ (mI,m) e_pos'[1](e_scr,EmptyPtree,[]);
 --^^^-- ausgeliehen von test-root-equ/sml *)
(*-------------- 9.6.03 --- cappend_ ... term -------irreparabler test
val (pt,_) = 
  cappend_problem EmptyPtree [] loc ([],(dI',pI',mI'));
val pos = (lev_on o lev_dn) [];
(* val pos = ([1]) *)
val (pt,_) = cappend_parent pt pos loc "{(a,b). is-max ..." 
    Empty_Tac TransitiveB;
val pos = (lev_on o lev_dn) pos;
(*val pos = ([1,1])*)
val (pt,_) = cappend_atomic pt pos loc "{(a,b). is-max ..." 
    Empty_Tac ("[1,1]:{(a,b). is-extremum ...",[]) Complete;
val pos = lev_on pos;
(*val pos = ([1,2])*)
val (pt,_) = cappend_atomic pt pos loc "{(a,b). is-extremum ..." 
    Empty_Tac ("[1,2]:{(a,b). f_x(a,b) ...",[]) Complete;
val pos = lev_up pos;
(*val pos = ([1])*)
val (pt,_) = append_result pt pos e_istate ("[1#]:{(a,b). f_x(a,b) ...",[])
    Complete;

val pos = lev_on pos;
(*val pos = ([2]) *)
val (pt,_) = cappend_atomic pt pos loc "{(a,b). f_x(a,b) ..." 
    Empty_Tac ("[2]:{(a,b). f_x & f_xx &...",[]) Complete;
val pos = lev_on pos;
(*al pos = [3] : pos*)
val (pt,_) = cappend_parent pt pos loc "{(a,b). f_x & f_xx &..." 
    Empty_Tac TransitiveB;
val pos = (lev_on o lev_dn) pos;
(*pos = ([3,1]) *)
val (pt,_) = cappend_atomic pt pos loc "{(a,b). f_x & f_xx & ..." 
    Empty_Tac ("[3,1]:{(a,b). f_x & f_xx } cup ...",[]) Complete;
val pos = lev_on pos;
(*pos = ([3,2]) *)
val (pt,_) = cappend_atomic pt pos loc "{(a,b). f_x & f_xx } cup.."
    Empty_Tac ("[3,2]:{(a,b). f_x ..} cup ...",[]) Complete;

val pos = lev_up pos;
(*pos = ([3]) *)
val (pt,_) = append_result pt pos e_istate ("[3#]:{(a,b). f_x ..} cup..",[])
    Complete;
val pos = lev_on pos;
(*val pos = [4] : pos *)
val (pt,_) = cappend_parent pt pos loc "{(a,b). f_x ..} cup ..." 
    Empty_Tac IntersectB;
val pos = (lev_on o lev_dn) pos;
(*val pos = ([4,1]) *)
val (pt,_) = cappend_parent pt pos loc "set_1 = ..." 
    Empty_Tac SequenceB;


val pos = (lev_on o lev_dn) pos;
(*val pos = ([4,1,1]) *)
val (pt,_) = cappend_parent(*pbl*) pt pos loc"f_x = d/dx x^3 ..."
    Empty_Tac TransitiveB;
val pos = (lev_on o lev_dn) pos;
(*val pos = ([4,1,1,1]) *)
val (pt,_) = cappend_parent pt pos loc "d/dx x^3 ..." 
    Empty_Tac TransitiveB;
val pos = (lev_on o lev_dn) pos;
(*val pos = ([4,1,1,1,1]) *)
val (pt,_) = cappend_atomic pt pos loc "d/dx x^3 ..." 
    Empty_Tac ("[4,1,1,1,1]:3x^2 + d/dx ...",[]) Complete;
val pos = lev_on pos;
(*val pos = ([4,1,1,1,2]) *)
val (pt,_) = cappend_atomic pt pos loc "3x^2 + d/dx ..." 
    Empty_Tac ("[4,1,1,1,2]:3x^2 + 0 + d/dx ...",[]) Complete;
val pos = lev_on pos;
(*pos = ([4,1,1,1,3]) *)
val (pt,_) = cappend_atomic pt pos loc "3x^2 + 0 + d/dx ..." 
    Empty_Tac ("[4,1,1,1,3]:3x^2 + 0 -3 ...",[]) Complete;
"--- 1 ---";
val pos = lev_up pos;
(*pos = ([4,1,1,1]) *)
val (pt,_) = append_result pt pos e_istate ("[4,1,1,1#]:3x^2 -3.",[])Complete;
"--- 2 ---";
val pos = lev_up pos;
(*val pos = ([4,1,1]) *)
val (pt,_) = append_result pt pos e_istate ("[4,1,1#]:found 3x^2 -3 ...",[])
    Complete;
"--- 3 ---";
val pos = lev_on pos;
(*val pos = ([4,1,2]+) *)
val (pt,_) = cappend_parent(*pbl*) pt pos loc "f_y = d/dy x^3 ..."
    Empty_Tac TransitiveB;
"--- 4 ---";
writeln (pr_ptree pr_short pt);

(*
.    ----- pblobj -----
1.   {(a,b). is-max ...
1.1.   {(a,b). is-max ...
1.2.   {(a,b). is-extremum ...
2.   {(a,b). f_x(a,b) ...
3.   {(a,b). f_x & f_xx &...
3.1.   {(a,b). f_x & f_xx & ...
3.2.   {(a,b). f_x & f_xx } cup..
4.   {(a,b). f_x ..} cup ...
4.1.   set_1 = ...
4.1.1.   f_x = d/dx x^3 ...
4.1.1.1.   d/dx x^3 ...
4.1.1.1.1.   d/dx x^3 ...
4.1.1.1.2.   3x^2 + d/dx ...
4.1.1.1.3.   3x^2 + 0 + d/dx ...
4.1.2.   f_y = d/dy x^3 ...
  
 use"test-max-surf1.sml";
   *)
-------------- 9.6.03 --- cappend_ ... term -------irreparabler test---*)


"--------- me .. scripts for maximum-example ---------------------";
"--------- me .. scripts for maximum-example ---------------------";
"--------- me .. scripts for maximum-example ---------------------";

val fmz =
    ["fixedValues [r=Arbfix]","maximum A",
     "valuesFor [a,b]",
     "relations [A=a*b, (a/2)^^^2 + (b/2)^^^2 = r^^^2]",
     "relations [A=a*b, (a/2)^^^2 + (b/2)^^^2 = r^^^2]",
     "relations [A=a*b, a/2=r*sin alpha, b/2=r*cos alpha]",

     "boundVariable a","boundVariable b","boundVariable alpha",
     "interval {x::real. 0 <= x & x <= 2*r}",
     "interval {x::real. 0 <= x & x <= 2*r}",
     "interval {x::real. 0 <= x & x <= pi}",
     "errorBound (eps=(0::real))"];
val (dI',pI',mI') =
  ("DiffApp.thy",["maximum_of","function"],
   ["DiffApp","max_by_calculus"]);

val (p,_,f,nxt,_,pt) = CalcTreeTEST [(fmz, (dI',pI',mI'))];
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = (me nxt p c pt) handle e => print_exn e;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
case nxt of (_, Specify_Method ["DiffApp","max_by_calculus"]) => ()
	  | _ => raise error "diffapp.sml: max-exp me, nxt = Specify_Method";

val oris = fst3 (get_obj g_origin pt (fst p)); writeln(oris2str oris);
val pits = get_obj g_pbl pt (fst p); writeln(itms2str_ ctxt pits);

val (p,_,f,nxt,_,pt) = me nxt p c pt;
val mits = get_obj g_met pt (fst p); writeln(itms2str_ ctxt mits);
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
case nxt of (_,Apply_Method ["DiffApp","max_by_calculus"] ) => ()
	  | _ => raise error "diffapp.sml: max-exp me, nxt = Apply_Method";
val (p,_,f,nxt,_,pt) = me nxt p c pt;

(*since 0508 Apply_Method does the 1st step, if NONE init_form -------------
(*val nxt = ("Subproblem",Subproblem ("DiffApp.thy",["make","function"]))*)
val (p,_,f,nxt,_,pt) = (me nxt p c pt) handle e => print_exn_G e;
(*val nxt = ("Refine_Tacitly",Refine_Tacitly ["make","function"])*)
val (p,_,f,nxt,_,pt) = me nxt p c pt;
(*val nxt = ("Model_Problem",Model_Problem ["by_explicit","make","function"])*)
----------------------------------------------------------------------------*)
case nxt of (_, Model_Problem(*["by_explicit", "make", "function"]*)) => ()
	  | _ => raise error "diffapp.sml: max-exp me, nxt = Model_Problem";

val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;

val oris = fst3 (get_obj g_origin pt (fst p));writeln(oris2str oris);
val pits = get_obj g_pbl pt (fst p);writeln(itms2str_ ctxt pits);

val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
case nxt of (_, Apply_Method ["DiffApp", "make_fun_by_explicit"]) => ()
	  | _ => raise error "diffapp.sml: max-exp Apply_Method ([1], Met) ";

(*----since WN050901 (ie. corr. mathengine#nxt_specify_ ..nxt_spec Pbl->p_
we get at ...
val (p,_,f,nxt,_,pt) = me nxt p c pt;
...
### assod: NotAss m= Subproblem'  ,
 stac= Substitute
 [(b, (rhs o hd)
       (Subproblem (thy, [normalize, polynomial, univariate, equation])))]
 (hd (filterVar A [A = a * b, (a / 2) ^^^ 2 + (b / 2) ^^^ 2 = r ^^^ 2]))
*** stac2tac_ TODO: no match for Substitute
***  [(b, (rhs o hd)
***        (Subproblem (thy, [normalize, polynomial, univariate, equation])))]
***  (hd (filterVar A [A = a * b, (a / 2) ^^^ 2 + (b / 2) ^^^ 2 = r ^^^ 2]))
Exception- ERROR raised

############################################################################
# presumerably didnt work before either, but not detected due to Emtpy_Tac #
############################################################################

(*val nxt = Subproblem ("DiffApp.thy",["univariate","equation"]))   *)
val (p,_,f,nxt,_,pt) = me nxt p c pt;
(*val nxt = Refine_Tacitly ["univariate","equation"])*)

val oris = fst3 (get_obj g_origin pt (fst p));writeln(oris2str oris);
val pits = get_obj g_pbl pt (fst p);writeln(itms2str_ ctxt pits);

val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
(*val nxt = ("Apply_Method",Apply_Method ["PolyEq","normalize_poly"])*)

val (p,_,f,nxt,_,pt) = me nxt p c pt;
(*val f = Form' (FormKF (~1,EdUndef,3,Nundef,"A = a * b"))*)
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
(*val f = Form' (FormKF (~1,EdUndef,4,Nundef,"[b = A / a]"))*)

------------------------------------------------------------------------*)

(*val f =
Error' (Error_ "Refine_Tacitly [\"univariate\",\"equation\"] not applicable")*)


(*----postponed.15.5.03 run scripts for maximum-example: univariate equation

val (p,_,f,nxt,_,pt) = (me nxt p c pt) handle e => print_exn e; 

val oris = fst3 (get_obj g_origin pt (fst p));writeln(oris2str oris);

val pits = get_obj g_pbl pt (fst p);writeln(itms2str_ ctxt pits);
val pits = get_obj g_pbl pt [];writeln(itms2str_ ctxt pits);

val mits = get_obj g_met pt (fst p);writeln(itms2str_ ctxt mits);
val mits = get_obj g_met pt [];writeln(itms2str_ ctxt mits);

itms2args thy ["DiffApp","max_by_calculus"] mits;

val (p,_,f,nxt,_,pt) = me nxt p c pt;

---*)

"--------- autoCalc .. scripts for maximum-example ---------------";
"--------- autoCalc .. scripts for maximum-example ---------------";
"--------- autoCalc .. scripts for maximum-example ---------------";
(*++++++++ see systest/inform.sml 'complete_metitms' ++++++++*)
 states:=[];
val fmz =
    ["fixedValues [r=Arbfix]","maximum A",
     "valuesFor [a,b]",
     "relations [A=a*b, (a/2)^2 + (b/2)^2 = r^2]",
     "relations [A=a*b, (a/2)^2 + (b/2)^2 = r^2]",
     "relations [A=a*b, a/2=r*sin alpha, b/2=r*cos alpha]",

     "boundVariable a","boundVariable b","boundVariable alpha",
     "interval {x::real. 0 <= x & x <= 2*r}",
     "interval {x::real. 0 <= x & x <= 2*r}",
     "interval {x::real. 0 <= x & x <= pi}",
     "errorBound (eps=(0::real))"];
val (dI',pI',mI') =
  ("DiffApp.thy",["maximum_of","function"],
   ["DiffApp","max_by_calculus"]);

 CalcTree [(fmz, (dI',pI',mI'))];
 Iterator 1; moveActiveRoot 1;
 autoCalculate 1 CompleteCalcHead;
 refFormula 1 (get_pos 1 1); 

 fetchProposedTactic 1;
 autoCalculate 1 (Step 1);

 fetchProposedTactic 1;
 autoCalculate 1 (Step 1);
 (*Subproblem on_interval maximum_of function*)
 autoCalculate 1 CompleteCalcHead;

 fetchProposedTactic 1;
 val ((pt,p),_) = get_calc 1;
 val mits = get_obj g_met pt (fst p);
 writeln (itms2str_ ctxt mits);
(*
 if itms2str_ ctxt mits = "[\n(1 ,[1] ,true ,#Given ,Cor functionEq (hd rs_) ,(t_, [hd rs_])),\n(2 ,[1] ,true ,#Given ,Cor boundVariable v_v ,(v_, [v_])),\n(3 ,[1] ,true ,#Given ,Cor interval itv_ ,(itv_, [itv_])),\n(4 ,[1] ,true ,#Find ,Cor maxArgument v__0 ,(v_0_, [v__0]))]" then ()
 else raise error "diffapp.sml: diff.behav. in autoCalc .. scripts for max 1";
*)
 (*FIXME: the environments contain identifers, and NOT values ?!?!?*)
(* WN051209 while extending 'fun step' for initac, this became better ...
 if itms2str_ ctxt mits = "[\n(1 ,[1,2,3] ,true ,#Given ,Cor fixedValues [r = Arbfix] ,(fix_, [[r = Arbfix]])),\n(2 ,[1,2,3] ,true ,#Find ,Cor maximum A ,(m_, [A])),\n(3 ,[1,2,3] ,true ,#Find ,Cor valuesFor [a, b] ,(vs_, [[a],[b]])),\n(4 ,[1,2] ,true ,#Relate ,Cor relations [A = a * b, (a / 2) ^^^ 2 + (b / 2) ^^^ 2 = r ^^^ 2] ,(rs_, [[A = a * b],[(a / 2) ^^^ 2 + (b / 2) ^^^ 2 = r ^^^ 2]])),\n(6 ,[1] ,true ,#undef ,Cor boundVariable a ,(v_, [a])),\n(9 ,[1,2] ,true ,#undef ,Cor interval {x. 0 <= x & x <= 2 * r} ,(itv_, [{x. 0 <= x & x <= 2 * r}])),\n(11 ,[1,2,3] ,true ,#undef ,Cor errorBound (eps = 0) ,(err_, [eps = 0]))]" then ()
 else raise error "diffapp.sml: diff.behav. in autoCalc .. scripts for max 1";
*)



"--------------------- 30.4.03: maximum .. rewrite_set_ list_rls ---------";
"--------------------- 30.4.03: maximum .. rewrite_set_ list_rls ---------";
"--------------------- 30.4.03: maximum .. rewrite_set_ list_rls ---------";
str2term
  "Script Maximum_value(fix_::bool list)(m_::real) (rs_::bool list)\
   \      (v_::real) (itv_::real set) (err_::bool) =          \ 
   \ (let e_e = (hd o (filterVar m_)) rs_;              \
   \      t_ = (if 1 < length_ rs_                            \
   \           then (SubProblem (Reals_,[make,function],[no_met])\
   \                     [real_ m_, real_ v_v, bool_list_ rs_])\
   \           else (hd rs_));                                \
   \      (mx_::real) = SubProblem (Reals_,[on_interval,max_of,function], \
   \                                [Isac,maximum_on_interval])\
   \                               [bool_ t_, real_ v_v, real_set_ itv_]\
   \ in ((SubProblem (Reals_,[find_values,tool],[Isac,find_values])   \
   \      [real_ mx_, real_ (Rhs t_), real_ v_v, real_ m_,     \
   \       bool_list_ (dropWhile (ident e_e) rs_)])::bool list))";

val fix_ = (str2term "fix_::bool list", 
	    str2term "[r=Arbfix]");
val m_   = (str2term "m_::real", 
	    str2term "A");
val rs_  = (str2term "rs_::bool list", 
	    str2term "[A = a*b, (a/2)^^^2 + (b/2)^^^2 = r^^^2]");
val v_v   = (str2term "v_::real", 
	    str2term "b");
val itv_ = (str2term "itv_::real set", 
	    str2term "{x::real. 0 <= x & x <= 2*r}");
val err_ = (str2term "err_::bool", 
	    str2term "eps=0");
val env = [fix_, m_, rs_ ,v_, itv_, err_];

(*--- 1.line in script ---*)
val t = str2term "(hd o (filterVar m_)) (rs_::bool list)";
val s = subst_atomic env t;
term2str s;
"(hd o filterVar A) [A = a * b, (a / 2) ^^^ 2 + (b / 2) ^^^ 2 = r ^^^ 2]";
val SOME (s',_) = rewrite_set_ thy false list_rls s;
val s'' = term2str s';
if s''="A = a * b" then () else raise error "new behaviour with list_rls 1.1.";
val env = env @ [(str2term "e_::bool",str2term "A = a * b")];

(*--- 2.line: condition alone ---*)
val t = str2term "1 < length_ (rs_::bool list)";
val s = subst_atomic env t;
term2str s;
"1 < length_ [A = a * b, (a / 2) ^^^ 2 + (b / 2) ^^^ 2 = r ^^^ 2]";
val SOME (s',_) = rewrite_set_ thy false list_rls s;
val s'' = term2str s';
if s''="True" then () else raise error "new behaviour with list_rls 1.2.";

(*--- 2.line in script ---*)
val t = str2term 
	    "(if 1 < length_ rs_                            \
   \           then (SubProblem (Reals_,[make,function],[no_met])\
   \                     [real_ m_, real_ v_v, bool_list_ rs_])\
   \           else (hd rs_))";
val s = subst_atomic env t;
term2str s;
"if 1 < length_ [A = a * b, (a / 2) ^^^ 2 + (b / 2) ^^^ 2 = r ^^^ 2]\
\then SubProblem (Reals_, [make, function], [no_met])\
\      [real_ A, real_ b,\
\       bool_list_ [A = a * b, (a / 2) ^^^ 2 + (b / 2) ^^^ 2 = r ^^^ 2]]\
\else hd [A = a * b, (a / 2) ^^^ 2 + (b / 2) ^^^ 2 = r ^^^ 2]";
val SOME (s',_) = rewrite_set_ thy false list_rls s;
val s'' = term2str s';
if s'' = 
"SubProblem (Reals_, [make, function], [no_met])\n\
\ [real_ A, real_ b,\n\
\  bool_list_ [A = a * b, (a / 2) ^^^ 2 + (b / 2) ^^^ 2 = r ^^^ 2]]" then ()
else raise error "new behaviour with list_rls 1.3.";
val env = env @ [(str2term "t_::bool",
		  str2term "A = (2*sqrt(r^^^2-(b/2)^^^2)) * b")];



"---------------------- 1.5.03: Make_fun_by_explicit ---------------------";
"---------------------- 1.5.03: Make_fun_by_explicit ---------------------";
"---------------------- 1.5.03: Make_fun_by_explicit ---------------------";
str2term
   "Script Make_fun_by_explicit (f_::real) (v_::real)         \
   \      (eqs_::bool list) =                                 \
   \ (let h_  = (hd o (filterVar f_)) eqs_;                   \
   \      e_1 = hd (dropWhile (ident h_) eqs_);               \
   \      vs_ = dropWhile (ident f_) (Vars h_);                \
   \      v_1 = hd (dropWhile (ident v_v) vs_);                \
   \      (s_1::bool list)=(SubProblem(Reals_,[univar,equation],[no_met])\
   \                          [bool_ e_1, real_ v_1])\
   \ in Substitute [(v_1 = (rhs o hd) s_1)] h_)";
val f_ = (str2term "f_::real", 
	  str2term "A");
val v_v = (str2term "v_::real", 
	  str2term "b");
val eqs_=(str2term "eqs_::bool list", 
	  str2term "[A = a * b, (a / 2) ^^^ 2 + (b / 2) ^^^ 2 = r ^^^ 2]");
val env = [f_, v_v, eqs_];

(*--- 1.line in script ---*)
val t = str2term "(hd o (filterVar v_v)) (eqs_::bool list)";
val s = subst_atomic env t;
term2str s;
val t = str2term 
     "(hd o filterVar b) [A = a * b, (a / 2) ^^^ 2 + (b / 2) ^^^ 2 = r ^^^ 2]";
val SOME (t',_) = rewrite_set_ thy false list_rls t;
val s' = term2str t';
if s' = "A = a * b" then () else raise error "new behaviour with list_rls 2.1";
val env = env @ [(str2term "h_::bool", str2term s')];

(*--- 2.line in script ---*)
val t = str2term "hd (dropWhile (ident h_) (eqs_::bool list))";
val s = subst_atomic env t;
term2str s;
val t = str2term 
	    "hd (dropWhile (ident (A = a * b))\
	    \     [A = a * b, (a / 2) ^^^ 2 + (b / 2) ^^^ 2 = r ^^^ 2])";
mem_rls "dropWhile_Cons" list_rls;
mem_rls "Atools.ident" list_rls;
val SOME (t',_) = rewrite_set_ thy false list_rls t;
val s' = term2str t';
if s' = "(a / 2) ^^^ 2 + (b / 2) ^^^ 2 = r ^^^ 2" then () 
else raise error "new behaviour with list_rls 2.2";
val env = env @ [(str2term "e_1::bool", str2term s')];

(*--- 3.line in script ---*)
val t = str2term "dropWhile (ident f_) (Vars (h_::bool))";
val s = subst_atomic env t;
term2str s;
val t = str2term "dropWhile (ident A) (Vars (A = a * b))";
val SOME (t',_) = rewrite_set_ thy false list_rls t;
val s' = term2str t';
if s' = "[a, b]" then () else raise error "new behaviour with list_rls 2.3";
val env = env @ [(str2term "vs_::real list", str2term s')];

(*--- 4.line in script ---*)
val t = str2term "hd (dropWhile (ident v_v) vs_)";
val s = subst_atomic env t;
term2str s;
val t = str2term "hd (dropWhile (ident b) [a, b])";
val SOME (t',_) = rewrite_set_ thy false list_rls t;
val s' = term2str t';
if s' = "a" then () else raise error "new behaviour with list_rls 2.4.";
val env = env @ [(str2term "v_1::real", str2term s')];

(*--- 5.line in script ---*)
val t = str2term "(SubProblem(Reals_,[univar,equation],[no_met])\
		 \           [bool_ e_1, real_ v_1])";
val s = subst_atomic env t;
term2str s;
"SubProblem (Reals_, [univar, equation], [no_met])\n\
\ [bool_ ((a / 2) ^^^ 2 + (b / 2) ^^^ 2 = r ^^^ 2), real_ a]";
val env = env @ [(str2term "s_1::bool list", 
		  str2term "[a = 2 * sqrt (r^^^2 - (b/2)^^^2)]")];

(*--- 6.line in script ---*)
val t = str2term "Substitute [(v_1 = (rhs o hd) (s_1::bool list))] (h_::bool)";
val s = subst_atomic env t;
term2str s;
val t = str2term 
"Substitute [(a = (rhs o hd) [a = 2 * sqrt (r ^^^ 2 - (b / 2) ^^^ 2)])]\n\
\ (A = a * b)";
mem_rls "Tools.rhs" list_rls;
val SOME (t',_) = rewrite_set_ thy false list_rls t;
val s' = term2str t';
if s' = "Substitute [a = 2 * sqrt (r ^^^ 2 - (b / 2) ^^^ 2)] (A = a * b)" 
then () else raise error "new behaviour with list_rls 2.6.";


"---------------------- 2.5.03: Make_fun_by_new_variable -----------------";
"---------------------- 2.5.03: Make_fun_by_new_variable -----------------";
"---------------------- 2.5.03: Make_fun_by_new_variable -----------------";
str2term
  "Script Make_fun_by_new_variable (f_::real) (v_::real)     \
   \      (eqs_::bool list) =                                 \
   \(let h_ = (hd o (filterVar f_)) eqs_;             \
   \     es_ = dropWhile (ident h_) eqs_;                    \
   \     vs_ = dropWhile (ident f_) (Vars h_);                \
   \     v_1 = nth_ 1 vs_;                                   \
   \     v_2 = nth_ 2 vs_;                                   \
   \     e_1 = (hd o (filterVar v_1)) es_;            \
   \     e_2 = (hd o (filterVar v_2)) es_;            \
   \  (s_1::bool list) = (SubProblem (Reals_,[univar,equation],[no_met])\
   \                    [bool_ e_1, real_ v_1]);\
   \  (s_2::bool list) = (SubProblem (Reals_,[univar,equation],[no_met])\
   \                    [bool_ e_2, real_ v_2])\
   \in Substitute [(v_1 = (rhs o hd) s_1),(v_2 = (rhs o hd) s_2)] h_)";
val f_ = (str2term "f_::real", 
	  str2term "A");
val v_v = (str2term "v_::real", 
	  str2term "alpha");
val eqs_=(str2term "eqs_::bool list", 
	  str2term "[A=a*b, a/2=r*sin alpha, b/2=r*cos alpha]");
val env = [f_, v_v, eqs_];

(*--- 1.line in script ---*)
val t = str2term "(hd o (filterVar (f_::real))) (eqs_::bool list)";
val s = subst_atomic env t;
term2str s;
val t = str2term 
"(hd o filterVar A) [A = a * b, a / 2 = r * sin alpha, b / 2 = r * cos alpha]";
trace_rewrite:=true;
val SOME (t',_) = rewrite_set_ thy false list_rls t;
trace_rewrite:=false;
val s' = term2str t';
if s' = "A = a * b" then() else raise error "new behaviour with list_rls 3.1.";
val env = env @ [(str2term "h_::bool", str2term s')];

(*--- 2.line in script ---*)
val t = str2term "dropWhile (ident (h_::bool)) (eqs_::bool list)";
val s = subst_atomic env t;
term2str s;
val t = str2term 
"dropWhile (ident (A = a * b))\
\ [A = a * b, a / 2 = r * sin alpha, b / 2 = r * cos alpha]";
val SOME (t',_) = rewrite_set_ thy false list_rls t;
val s' = term2str t';
if s' = "[a / 2 = r * sin alpha, b / 2 = r * cos alpha]" 
then () else raise error "new behaviour with list_rls 3.2.";
val env = env @ [(str2term "es_::bool list", str2term s')];

(*--- 3.line in script ---*)
val t = str2term "dropWhile (ident (f_::real)) (Vars (h_::bool))";
val s = subst_atomic env t;
term2str s;
val t = str2term "dropWhile (ident A) (Vars (A = a * b))";
val SOME (t',_) = rewrite_set_ thy false list_rls t;
val s' = term2str t';
if s' = "[a, b]" then () else raise error "new behaviour with list_rls 3.3.";
val env = env @ [(str2term "vs_::real list", str2term s')];

(*--- 4.line in script ---*)
val t = str2term "nth_ 1 vs_";
val s = subst_atomic env t;
term2str s;
val t = str2term "nth_ 1 [a, b]";
val SOME (t',_) = rewrite_set_ thy false list_rls t;
val s' = term2str t';
if s' = "a" then () else raise error "new behaviour with list_rls 3.4.";
val env = env @ [(str2term "v_1", str2term s')];

(*--- 5.line in script ---*)
val t = str2term "nth_ 2 vs_";
val s = subst_atomic env t;
term2str s;
val t = str2term "nth_ 2 [a, b]";
val SOME (t',_) = rewrite_set_ thy false list_rls t;
val s' = term2str t';
if s' = "b" then () else raise error "new behaviour with list_rls 3.5.";
val env = env @ [(str2term "v_2", str2term s')];

(*--- 6.line in script ---*)
val t = str2term "(hd o (filterVar v_1)) (es_::bool list)";
val s = subst_atomic env t;
term2str s;
val t = str2term 
	   "(hd o filterVar a) [a / 2 = r * sin alpha, b / 2 = r * cos alpha]";
val SOME (t',_) = rewrite_set_ thy false list_rls t;
val s' = term2str t';
if s' = "a / 2 = r * sin alpha" then () 
else raise error "new behaviour with list_rls 3.6.";
val e_1 = str2term "e_1::bool";
val env = env @ [(e_1, str2term s')];

(*--- 7.line in script ---*)
val t = str2term "(hd o (filterVar v_2)) (es_::bool list)";
val s = subst_atomic env t;
term2str s;
val t = str2term 
	  "(hd o filterVar b) [a / 2 = r * sin alpha, b / 2 = r * cos alpha]";
val SOME (t',_) = rewrite_set_ thy false list_rls t;
val s' = term2str t';
if s' = "b / 2 = r * cos alpha" then () 
else raise error "new behaviour with list_rls 3.7.";
val env = env @ [(str2term "e_2::bool", str2term s')];

(*--- 8.line in script ---*)
val t = str2term "(SubProblem (Reals_,[univar,equation],[no_met])\
		 \            [bool_ e_1, real_ v_1])";
val s = subst_atomic env t;
term2str s;
"SubProblem (Reals_, [univar, equation], [no_met])\
	    \ [bool_ (a / 2 = r * sin alpha), real_ a]";
val s_1 = str2term "[a = 2*r*sin alpha]";
val env = env @ [(str2term "s_1::bool list", s_1)];

(*--- 9.line in script ---*)
val t = str2term "(SubProblem (Reals_,[univar,equation],[no_met])\
   \                    [bool_ e_2, real_ v_2])";
val s = subst_atomic env t;
term2str s;
"SubProblem (Reals_, [univar, equation], [no_met])\
	    \ [bool_ (b / 2 = r * cos alpha), real_ b]";
val s_2 = str2term "[b = 2*r*cos alpha]";
val env = env @ [(str2term "s_2::bool list", s_2)];

(*--- 10.line in script ---*)
val t = str2term 
"Substitute [(v_1 = (rhs o hd) s_1),(v_2 = (rhs o hd) s_2)] (h_::bool)";
val s = subst_atomic env t;
term2str s;
"Substitute\n [(a = (rhs o hd) [a = 2 * r * sin alpha]),\
\              (b = (rhs o hd) [b = 2 * r * cos alpha])] (A = a * b)";
val SOME (s',_) = rewrite_set_ thy false list_rls s;
val s'' = term2str s';
if s'' = 
"Substitute [a = 2 * r * sin alpha, b = 2 * r * cos alpha] (A = a * b)"
then () else raise error "new behaviour with list_rls 3.10.";





